diff --git a/app/test-pmd/cmdline_flow.c b/app/test-pmd/cmdline_flow.c
index a78154502..c318b4a27 100644
--- a/app/test-pmd/cmdline_flow.c
+++ b/app/test-pmd/cmdline_flow.c
@@ -342,8 +342,17 @@ enum index {
 	ACTION_SET_IPV4_DSCP_VALUE,
 	ACTION_SET_IPV6_DSCP,
 	ACTION_SET_IPV6_DSCP_VALUE,
+	ACTION_DBDF,
 };
 
+#define DBDF_KEY_LENGTH 20
+
+struct action_dbdf_data {
+	struct rte_flow_action_dbdf conf;
+	uint8_t dbdf_value[DBDF_KEY_LENGTH];
+};
+
+
 /** Maximum size for pattern in struct rte_flow_item_raw. */
 #define ITEM_RAW_PATTERN_SIZE 40
 
@@ -1144,6 +1153,7 @@ static const enum index next_action[] = {
 	ACTION_SET_META,
 	ACTION_SET_IPV4_DSCP,
 	ACTION_SET_IPV6_DSCP,
+	ACTION_DBDF,
 	ZERO,
 };
 
@@ -1369,6 +1379,11 @@ static const enum index action_set_ipv6_dscp[] = {
 	ZERO,
 };
 
+static const enum index action_dbdf[] = {
+	ACTION_NEXT,
+	ZERO,
+};
+
 static int parse_set_raw_encap_decap(struct context *, const struct token *,
 				     const char *, unsigned int,
 				     void *, unsigned int);
@@ -1421,6 +1436,9 @@ static int parse_vc_action_mplsoudp_encap(struct context *,
 static int parse_vc_action_mplsoudp_decap(struct context *,
 					  const struct token *, const char *,
 					  unsigned int, void *, unsigned int);
+static int parse_vc_action_dbdf_value(struct context *,
+				     const struct token *, const char *,
+				     unsigned int, void *, unsigned int);
 static int parse_vc_action_raw_encap(struct context *,
 				     const struct token *, const char *,
 				     unsigned int, void *, unsigned int);
@@ -3684,6 +3702,18 @@ static const struct token token_list[] = {
 			     (struct rte_flow_action_set_dscp, dscp)),
 		.call = parse_vc_conf,
 	},
+	[ACTION_DBDF] = {
+		.name = "dbdf",
+		.help = "set DBDF value",
+		.next = NEXT(action_dbdf, NEXT_ENTRY(STRING)),
+		.priv = PRIV_ACTION(DBDF, sizeof(struct action_dbdf_data)),
+		.args = ARGS(ARGS_ENTRY_ARB(0, 0),
+			     ARGS_ENTRY_ARB(0, sizeof(uint8_t)),
+			     ARGS_ENTRY_ARB(
+			    offsetof(struct action_dbdf_data, dbdf_value),
+					    DBDF_KEY_LENGTH)),
+		.call = parse_vc_action_dbdf_value,
+	},
 };
 
 /** Remove and return last entry from argument stack. */
@@ -5064,6 +5094,40 @@ parse_vc_action_raw_encap_index(struct context *ctx, const struct token *token,
 	return len;
 }
 
+static int
+parse_vc_action_dbdf_value(struct context *ctx, const struct token *token,
+			  const char *str, unsigned int len, void *buf,
+			  unsigned int size)
+{
+	struct buffer *out = buf;
+	struct rte_flow_action *action;
+	struct action_dbdf_data *action_dbdf_data = NULL;
+	int ret;
+
+	ret = parse_vc(ctx, token, str, len, buf, size);
+	if (ret < 0)
+		return ret;
+	/* Nothing else to do if there is no buffer. */
+	if (!out)
+		return ret;
+	if (!out->args.vc.actions_n)
+		return -1;
+	action = &out->args.vc.actions[out->args.vc.actions_n - 1];
+	/* Point to selected object. */
+	ctx->object = out->args.vc.data;
+	ctx->objmask = NULL;
+	/* Copy the headers to the buffer. */
+	action_dbdf_data = ctx->object;
+	*action_dbdf_data = (struct action_dbdf_data) {
+		.conf = (struct rte_flow_action_dbdf){
+			.dbdf_value = action_dbdf_data->dbdf_value,
+		},
+		.dbdf_value = {},
+	};
+	action->conf = &action_dbdf_data->conf;
+	return ret;
+}
+
 static int
 parse_vc_action_raw_encap(struct context *ctx, const struct token *token,
 			  const char *str, unsigned int len, void *buf,
diff --git a/doc/guides/prog_guide/rte_flow.rst b/doc/guides/prog_guide/rte_flow.rst
index 41c147913..b900e283c 100644
--- a/doc/guides/prog_guide/rte_flow.rst
+++ b/doc/guides/prog_guide/rte_flow.rst
@@ -2616,6 +2616,25 @@ Otherwise, RTE_FLOW_ERROR_TYPE_ACTION error will be returned.
    | ``dscp``  | DSCP in low 6 bits, rest ignore |
    +-----------+---------------------------------+
 
+Action: ``DBDF``
+^^^^^^^^^^^^^^^^^^^^^^^^^
+
+Set DBDF value.
+
+Send traffic to specified PCI DBDF device.
+
+.. _table_rte_flow_action_dbdf:
+
+.. table:: DBDF
+
+   +-----------------+----------------------------+
+   | Field           | Value                      |
+   +=================+============================+
+   | ``length``      | DBDF length                |
+   +-----------------+----------------------------+
+   | ``dbdf_value``  | DBDF value                 |
+   +-----------------+----------------------------+
+
 Negative types
 ~~~~~~~~~~~~~~
 
diff --git a/lib/librte_ethdev/rte_flow.c b/lib/librte_ethdev/rte_flow.c
index a5ac1c7fb..6eada7785 100644
--- a/lib/librte_ethdev/rte_flow.c
+++ b/lib/librte_ethdev/rte_flow.c
@@ -172,6 +172,7 @@ static const struct rte_flow_desc_data rte_flow_desc_action[] = {
 	MK_FLOW_ACTION(SET_META, sizeof(struct rte_flow_action_set_meta)),
 	MK_FLOW_ACTION(SET_IPV4_DSCP, sizeof(struct rte_flow_action_set_dscp)),
 	MK_FLOW_ACTION(SET_IPV6_DSCP, sizeof(struct rte_flow_action_set_dscp)),
+	MK_FLOW_ACTION(DBDF, sizeof(struct rte_flow_action_dbdf)),
 };
 
 int
diff --git a/lib/librte_ethdev/rte_flow.h b/lib/librte_ethdev/rte_flow.h
index b43238b45..b6029c282 100644
--- a/lib/librte_ethdev/rte_flow.h
+++ b/lib/librte_ethdev/rte_flow.h
@@ -2082,6 +2082,22 @@ enum rte_flow_action_type {
 	 * See struct rte_flow_action_set_dscp.
 	 */
 	RTE_FLOW_ACTION_TYPE_SET_IPV6_DSCP,
+
+	/**
+	 * Send packet to specified PCIe device
+	 */
+	RTE_FLOW_ACTION_TYPE_DBDF,
+};
+
+
+/**
+ * RTE_FLOW_ACTION_TYPE_DBDF
+ *
+ * Send the packet to specified PCI DBDF device
+ */
+struct rte_flow_action_dbdf {
+	uint8_t length;
+	const uint8_t *dbdf_value;
 };
 
 /**